/*
 * General header file for Applix 1616 code
 */

#ifndef STDIN
#define STDERR		0x100	/* Standard error file descriptor */
#define STDOUT		0x101	/* Standard output file descriptor */
#define STDIN		0x102	/* Standard input file descriptor */
#endif

/* Fix up typing */
extern int syscall();

#define coldboot()			syscall(101)
#define warmboot(n)			syscall(1, n)
#define getchar()			syscall(2)
#define sgetchar()			syscall(3)
#define putchar(ch)			syscall(4, ch)
#define sputchar()			syscall(5)
#define getc(dvr)			syscall(6, dvr)
#define sgetc(dvr)			syscall(7, dvr)
#define putc(dvr, ch)			syscall(8, dvr, ch)
#define sputc(dvr)			syscall(9, dvr)
#define add_ipdvr(io, stat, name, pv)	syscall(10, io, stat, name, pv)
#define add_xipdvr(io, stat, name,pv,m)	syscall(10, io, stat, name, pv, m)
#define loadrel(ifd, addr)		syscall(11, ifd, addr)
#define add_opdvr(io, stat, name, pv)	syscall(12, io, stat, name, pv)
#define exit(i)				syscall(13, i)
#define set_sip(dvr)			syscall(14, dvr)
#define set_sop(dvr)			syscall(15, dvr)
#define set_vsvec(vec, rate, callval)	syscall(16, vec, rate, callval)
#define clr_vsvec(vnum)			syscall(17, vnum)
#define get_ticks()			syscall(18)
#define get_cpu()			syscall(19)
#define set_ser(dvr)			syscall(20, dvr)
#define caswraw(start, length, leader)	syscall(21, start, length, leader)
#define casrraw(buf, leader, maxhunk)	syscall(22, buf, leader, maxhunk)
#define getdate(str)			syscall(23, str)
#define setdate(str)			syscall(24, str)
#define abortstat()			syscall(25)
#define ent1ints(vec, preload)		syscall(26, vec, preload)
#define dist1ints()			syscall(27)
#define sine(i)				syscall(28, i)
#define def_fk(fknum, str)		syscall(29, fknum, str)
#define getrand()			syscall(30)
#define set_640(mode)			syscall(31, mode)
#define set_vdp(page)			syscall(32, page)
#define set_vap(page)			syscall(33, page)
#define set_fgcol(col)			syscall(34, col)
#define set_bgcol(col)			syscall(35, col)
#define set_bdcol(col)			syscall(36, col)
#define set_pal(palpos, col)		syscall(37, palpos, col)
#define rdch_shape(chno)		syscall(38, chno)
#define def_chshape(chno, defptr)	syscall(39, chno, defptr)
#define def_wind(wind)			syscall(40, wind)
#define vid_address(x, y)		syscall(41, x, y)
#define move_wind(buf, mode)		syscall(42, buf, mode)
#define rawvid(row, col, ch, fg, bg)	syscall(43, row, col, ch, fg, bg)
#define fill_wind(col)			syscall(44, col)
#define scurs_mode(rate, en, mask)	syscall(45, rate, en, mask)
#define mousetrap(n, v)			syscall(46, n, v)
#define fill(x, y, val)			syscall(47, x, y, val)
#define rset_pel(x, y, val)		syscall(50, x, y, val)
#define set_pel(x, y, val)		syscall(51, x, y, val)
#define rline(x0, y0, x1, y1)		syscall(52, x0, y0, x1, y1)
#define drawline(x0, y0, x1, y1)	syscall(53, x0, y0, x1, y1)
#define rread_pel(x, y)			syscall(54, x, y)
#define read_pel(x, y)			syscall(55, x, y)
#define sgfgcol(val)			syscall(56, val)
#define rcircle(x, y, radius)		syscall(59, x, y, radius)
#define circle(x, y, radius)		syscall(60, x, y, radius)
#define sdotmode(mode)			syscall(61, mode)
#define getmem(nbytes, mode)		syscall(62, nbytes, mode)
#define getfmem(first, nbytes, mode)	syscall(63, first, nbytes, mode)
#define freemem(addr)			syscall(64, addr)
#define chdir(addr)			syscall(65, addr)
#define mkdir(addr, n)			syscall(66, addr, n)
#define getfullpath(path, mode)		syscall(67, path, mode)
#define pathcmp(p1, p2)			syscall(68, p1, p2)
#define floadrel(path, gm)		syscall(69, path, gm)
#define anipsel(ipnum)			syscall(70, ipnum)
#define anopsel(opnum)			syscall(71, opnum)
#define anopdis(n)			syscall(72, n)
#define adc()				syscall(73)
#define dac(val)			syscall(74, val)
#define set_led(val)			syscall(75, val)
#define freetone(table, tablen, l, p)	syscall(76, table, tablen, l, p)
#define fttime()			syscall(77)
#define	rdiport()			syscall(78)
#define rdbiport()			syscall(79)
#define setstvec(vecnum, whereto)	syscall(80, vecnum, whereto)
#define new_cbuf(bnum, addr, len)	syscall(81, bnum, addr, len)
#define prog_sio(chan, spptr)		syscall(82, chan, spptr)
#define gettdstr(buf)			syscall(83, buf)
#define nledit(str, len)		syscall(84, str, len)
#define ledit(str)			syscall(86, str)
#define iexec(prompt)			syscall(87, prompt)
#define exec(lb)			syscall(88, lb)
#define callmrd(n, cmd, arg)		syscall(89, n, cmd, arg)
#define set_kvec(vec)			syscall(90, vec)
#define clparse(a, t, v)		syscall(91, a, t, v)
#define qsort(b, n, w, c)		syscall(92, b, n, w, c)
#define sliceargs(s, a, c)		syscall(93, s, a, c)
#define cpuspeed()			syscall(94)
#define find_driver(ioro, name)		syscall(95, ioro, name)
#define get_dvrlist(ioro)		syscall(96, ioro)
#define execa(argv)			syscall(97, argv)
#define execv(path, argv)		syscall(98, path, argv)
#define option(opnum, set)		syscall(99, opnum, set)
#define inst_bdvr(br, bw, bs, name, b)	syscall(100, br, bw, bs, name, b)
#define find_bdvr(name)			syscall(102, name)
#define blkread(blk, buf, dev)		syscall(103, blk, buf, dev)
#define blkwrite(blk, buf, dev)		syscall(104, blk, buf, dev)
#define open(name, mode)		syscall(105, name, mode)
#define read(fd, buf, nbytes)		syscall(106, fd, buf, nbytes)
#define close(fd)			syscall(107, fd)
#define creat(name, bits, addr)		syscall(108, name, bits, addr)
#define write(fd, buf, nbytes)		syscall(109, fd, buf, nbytes)
#define unlink(name)			syscall(110, name)
#define rename(old, new)		syscall(111, old, new)
#define filestat(name, buf)		syscall(112, name, buf)
#define readdir(dev, buf, dp, pos, par)	syscall(113, dev, buf, dp, pos, par)
#define interpbec(ec, buf)		syscall(114, ec, buf)
#define seek(fd, offset, mode)		syscall(115, fd, offset, mode)
#define tell(fd)			syscall(116, fd)
#define bdmisc(bdnum, code, arg1)	syscall(117, bdnum, code, arg1)
#define processdir(pn, buf, mode)	syscall(118, pn, buf, mode)
#define multiblkio(bd, cmd, ad, b, nb)	syscall(119, bd, cmd, ad, b, nb)
#define fputs(fd, buf)			syscall(121, fd, buf)
#define errmes(ec)			syscall(122, ec)
#define fgets(fd, buf)			syscall(123, fd, buf)
#define rdalldir(p, mm, sm, ps)		syscall(124, p, mm, sm, ps)
#define oscontrol(a1, a2)		syscall(125, a1, a2)
#define getromver()			syscall(126)
#define z80lock(c, p1)			syscall(127, c, p1)
#define aexeca(argv, isasync)		syscall(128, argv, isasync)
#define proccntl(mode, arg1, arg2)	syscall(129, mode, arg1, arg2)
#define newchset(ptr)			syscall(130, newchset)
#define schedprep(addr, av, flags, ss)	syscall(131, addr, av, flags, ss)
#define pipe(p)				syscall(132, p)
#define cdmisc(dvr, cmd, p1, p2, p3)	syscall(133, dvr, cmd, p1, p2, p3)
#define cdmisc4(dvr, cmd, p1, p2)	syscall(133, dvr, cmd, p1, p2)
#define cdmisc3(dvr, cmd, p1)		syscall(133, dvr, cmd, p1)
#define cdmisc2(dvr, cmd)		syscall(133, dvr, cmd)
#define alias(cmd, arg)			syscall(135, cmd, arg)
#define SPR(fmt, putcf, arg)		syscall(139, fmt, putcf, arg)

#define crtc_init(mode, p)		syscall(140, mode, p)
#define chkperm(pdirent, mask, path)	syscall(141, pdirent, mask, path)
#define fnledit(buf, len, in, out)	syscall(142, buf, len, in, out)

/* Various modes for proccntl */
#define getpid()			syscall(129, 0)
#define getppid(pid)			syscall(129, 1, pid)
#define kill(pid)			syscall(129, 3, pid)
#define sleep(ticks)			syscall(129, 4, ticks)
#define getproctab(pid)			syscall(129, 5, pid)
#define cwd(pid, path)			syscall(129, 6, pid, path)
#define lockin(mode)			syscall(129, 7, mode)
#define runstats(mode)			syscall(129, 8, mode)
#define wait(pid)			syscall(129, 9, pid)
#define nice(pid, v)			syscall(129, 10, pid, v)
#define sigsend(pid, v1, v2)		syscall(129, 11, pid, v1, v2)
#define sigcatch(v)			syscall(129, 12, v)
#define sendinterrupt(rp)		syscall(129, 13, rp)
#define proctrace(rp)			syscall(129, 14, rp)
#define getprocflags(pid)		syscall(129, 15, pid)
#define isinteractive(pid)		syscall(129, 16, pid)
#define nospcheck(pid, mode)		syscall(129, 17, pid, mode)
#define csvec(vec)			syscall(129, 18, vec)
#define getpcurpid()			syscall(129, 19)
#define readsigvec(pid)			syscall(129, 20, pid)
#define fsbptr()			syscall(129, 21)
#define fspptr()			syscall(129, 22)
#define ssptr()				syscall(129, 23)
#define killuser(homeshell)		syscall(129, 24, homeshell)
#define sigblock(pid, blk)		syscall(129, 25, pid, blk)
#define alarm(n)			syscall(129, 26, n)
#define sigblocker(rootpid, sig, arg)	syscall(129, 27, rootpid, sig, arg)
#define snooze(vec, p1, p2)		syscall(129, 28, vec, p1, p2)
#define siguser(pid, sig, arg)		syscall(129, 29, pid, sig, arg)
#define lastchild(pid)			syscall(129, 32, pid)
#define swpptr()			syscall(129, 33)
#define killdown(startpid)		syscall(129, 34, startpid)
#define sigdown(startpid, val1, val2)	syscall(129, 35, startpid, val1, val2)
#define killuid(uid)			syscall(129, 36, uid)
#define siguid(uid, p1, p2)		syscall(129, 37, uid, p1, p2)
#define setsigexit(pid, mode)		syscall(129, 38, pid, mode)
#define setpg(pg)			syscall(129, 39, pg)
#define sigpg(pg, sig, arg)		syscall(129, 40, pg, sig, arg)
#define killpg(pg)			syscall(129, 41, pg)
#define setprocumask(pid, umask)	syscall(129, 42, pid, umask)
#define setenvbits(pid, mask, set)	syscall(129, 43, pid, mask, set)
#define getenvbits(pid)			syscall(129, 44, pid)
#define nametopid(name)			syscall(129, 45, name)
#define blocktx(pid, addr, len, sig)	syscall(129, 46, pid, addr, len, sig)
#define blockrx(mode)			syscall(129, 47, mode)
#define setenv(pid, name, set, mode)	syscall(129, 48, pid, name, set, mode)
#define getenv(pid, name, mode)		syscall(129, 49, pid, name, mode)

#define envsub(s, dollaronly, mmode)	syscall(125, 35, s, dollaronly, mmode)
#define doassign(argc, argv)		syscall(125, 36, argc, argv)

#define movmem(from, to, len)	_movmem(from, to, len)
#define swapmem(p1, p2, len)	_swapmem(p1, p2, len)
#define bsetmem(add, val, num)	_bsetmem(add, val, num)
#define wsetmem(add, val, num)	_wsetmem(add, val, num)
#define lsetmem(add, val, num)	_lsetmem(add, val, num)
