; TABS8
		psect	text
;
; Field trap #SYSTEM calls by saving registers and vectoring to code.
; The code is entered with the following parameters: code(d1, d2, a0, a1, a2)
;

		global	_sys_trap,_rjtab	; , _trappcsave
		global	_syssafe,_switchpending,_syssp
		global	__empty,_lastsyscall

_sys_trap:	movem.l	d1/d2/d3/a0/a1/a2/a3,-(sp)
;		move.l	30(sp),_trappcsave		; Call PC
		cmp.w	#149,d0			; d0 - size
		bcs.b	goodcall		; Branch if <
		jmp	__empty			; Bad system call
goodcall:	movem.l	d1/d2/a0/a1/a2,-(sp)	; Stack passed parameters
		move.w	d0,_lastsyscall
		asl.l	#2,d0
		move.l	#_rjtab,a0
		move.l	0(a0,d0.w),a0
		jsr	(a0)			; Go to code
		add.l	#20,sp			; Adjust the stack
		movem.l	(sp)+,d1/d2/d3/a0/a1/a2/a3

; Is a process switch pending?
scexit:
		move.w	d0,-(sp)
		move.w	sr,d0			; Check we are at level 0
		and.w	#$0700,d0
		beq.b	canswtch
		move.w	(sp)+,d0
		bra.b	noswtch			; No switch if not at level 0
canswtch:	move.w	(sp)+,d0
		or.w	#$0300,sr		; Stop interrupts
		tst.l	_switchpending
		beq.b	noswtch
		tst.l	_syssafe
		bne.b	noswtch			; Can't interrupt system
; OK, save registers and return to scheduler
;		clr.l	_switchpending
		; Save user regs
		movem.l	d0/d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6,-(sp)
		move.l	sp,d0			; User SP
		move.l	_syssp,sp
		; Restore scheduler's regs
		movem.l	(sp)+,d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6
noswtch:	rte				; Restore interrupt level

;
; The Line A trap entry point
;
		global	__linea,_is68010
__linea:	move.l	2(sp),a0		; The Call PC
		;Unusual: the line A trap appears to push the address of the
		;offending opcode, not the address + 2!
		move.w	(a0),d0			; The Line A opcode
		and.w	#$fff,d0		; The system call number
		cmp.w	#149,d0
		bcs.b	goodlinea
;		move.l	a0,_trappcsave		; Call PC
		jmp	__empty			; Bad system call
goodlinea:	move.w	d0,_lastsyscall
		asl.l	#2,d0			; Long index
		move.l	#_rjtab,a0		; RAM jump table
		move.l	0(a0,d0.w),a0
		addq.l	#2,2(sp)		; Return address points to next opcode
		lea	28(sp),a1		; Pointer to last arg for 68010
		tst.b	_is68010
		bne.b	linea010
		subq.l	#2,a1			; 2 less bytes for 68000

linea010:
		movem.l	d2/d3/a2/a3,-(sp)	; Save local registers from Hitech C
		move.l	-(a1),-(sp)		; Restack the arguments to the
		move.l	-(a1),-(sp)		; system call
		move.l	-(a1),-(sp)
		move.l	-(a1),-(sp)
		move.l	-(a1),-(sp)
		jsr	(a0)			; Do the call
		add.w	#20,sp			; Adjust for stacked args
		movem.l	(sp)+,d2/d3/a2/a3
		bra	scexit			; Go test for context switch

;
; Reschedule user code
;

		global	_enterproc,_syssp
_enterproc:
		move.w	sr,-(sp)		; Stack SR for RTE exit
		move.l	6(sp),d0		; User SP
		movem.l	d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6,-(sp)	; Scheduler regs
		move.l	sp,_syssp
		move.l	d0,sp
		movem.l	(sp)+,d0/d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5/a6 ; User regs
		rte

; Return point for programs which return from their signal handlers
		global	_sigreturn
_sigreturn:
		addq.l	#6,sp			; Adjust for pushed args
		addq.l	#6,sp			; Adjust for pushed args
		movem.l	(sp)+,#$7fff		; Restore normal user code context
		rte				; Return to user code

; Come here if user program ends via RTS
		global	_procreturn
_procreturn:	move.l	d0,d2			; Exit code
		bra	doex
;
; Entry point for the exit() system call 13
;
		global	_exit,__exit
__exit:
_exit:		move.l	4(sp),d2
doex:		move.l	#129,d0			; proccntl(2, code)
		moveq.l	#2,d1			; exit
		trap	#7

		trap	#1

;
; Enter user transient program here
;
; Usage: entry(addr, nargs, argstr, argtype, argval, p1, p2)
;               8      12     16      20       24    28  32
;
		global	_entry
_entry:		link	a6,#0
		movem.l	d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5,-(sp)
		move.l	32(a6),-(sp)
		move.l	28(a6),-(sp)
		move.l	24(a6),-(sp)	; Start pushing args to user program
		move.l	20(a6),-(sp)
		move.l	16(a6),-(sp)
		move.l	12(a6),-(sp)	; All pushed
		move.l	8(a6),a0	; Pointer to code
		jsr	(a0)		; Ta Ta
;Return point
doexit:		add.l	#24,sp
		movem.l	(sp)+,d1/d2/d3/d4/d5/d6/d7/a0/a1/a2/a3/a4/a5
		unlk	a6
		rts

		global	__warmboot,__getchar,__sgetchar
		global	__putchar,__sputchar,__getc,__sgetc
		global	__putc,__sputc,__add_ipdvr,__loadrel
		global	__add_opdvr,__exit,__set_sip,__set_sop
		global	__set_vsvec,__clr_vsvec,__get_ticks,__get_cpu
		global	__set_ser,__caswraw,__casrraw,__getdate
		global	__setdate,__abortstat,__ent1ints,__dist1ints
		global	__sine,__def_fk,__getrand,__set_640
		global	__set_vdp,__set_vap,__set_fgcol,__set_bgcol
		global	__set_bdcol,__set_pal,__rdch_shape,__def_chshape
		global	__def_wind,__vid_address,__move_wind,_draw_vchar
		global	__fill_wind,__scurs_mode,__mousetrap,__fill
		global	_printf,_sprintf,__rset_pel,__set_pel
		global	__rline,__line,__rread_pel,__read_pel
		global	__sgfgcol,__sgbgcol,__sgtexture,__rcircle
		global	__circle,__sdotmode,__getmem,__getfmem
		global	__freemem,__chdir,__mkdir,__getfullpath
		global	__pathcmp,__floadrel,__anipsel,__anopsel
		global	__anopdis,__adc,__dac,__set_led
		global	__freetone,__fttime,__rdiport,__rdbiport
		global	__setstvec,__new_cbuf,__prog_sio,__gettdstr
		global	__nledit,__empty,__ledit,__iexec
		global	__exec,__callmrd,__set_kvec,__clparse
		global	__qsort,__sliceargs,__cpuspeed,__find_driver
		global	__get_dvrlist,__execa,__execv,__option
		global	__inst_bdvr,__coldboot,__find_bdvr,__blkread
		global	__blkwrite,__open,__read,__close
		global	__creat,__write,__unlink,__rename
		global	__filestat,__readdir,__interpbec,__seek
		global	__tell,__bdmisc,__processdir,__multiblkio
		global	_fprintf,__fputs,__errmes,__fgets
		global	__rdalldir,__oscontrol,__getromver ;,__osrequest
		global	__z80lock,__aexeca,__proccntl,__newchset
		global	__schedprep,__pipe,__cdmisc,__alias,__xbread
		global	__spr,__crtc_init,__chkperm,__fnledit,__set_cpu

		global	_jtab
_jtab:
	dc.l	__warmboot	; 0: Warm boot the system
	dc.l	__warmboot	; 1: Warm boot the system
	dc.l	__getchar	; 2: Standard I/P
	dc.l	__sgetchar	; 3: Standard I/P status
	dc.l	__putchar	; 4: Standard O/P
	dc.l	__sputchar	; 5: Standard O/P status
	dc.l	__getc		; 6: Call an I/P driver
	dc.l	__sgetc		; 7: Get I/P driver status
	dc.l	__putc		; 8: Call an O/P driver
	dc.l	__sputc		; 9: Get O/P driver status
	dc.l	__add_ipdvr	; 10: Install an I/P driver
	dc.l	__loadrel	; 11: Load relocatable code
	dc.l	__add_opdvr	; 12: Install an O/P driver
	dc.l	__exit		; 13: User abort code
	dc.l	__set_sip	; 14: Assign standard I/P
	dc.l	__set_sop	; 15: Assign standard O/P
	dc.l	__set_vsvec	; 16: Install a VS vector
	dc.l	__clr_vsvec	; 17: Delete a VS vector
	dc.l	__get_ticks	; 18: Return VS count
	dc.l	__get_cpu	; 19: Return CPU type
	dc.l	__set_ser	; 20: Set standard error
	dc.l	__caswraw	; 21: Raw cassette O/P
	dc.l	__casrraw	; 22: Raw cassette I/P
	dc.l	__getdate	; 23: Get the date and time
	dc.l	__setdate	; 24: Set the date and time
	dc.l	__abortstat	; 25: Read abort status
	dc.l	__ent1ints	; 26: Enable timer1 output interrupts
	dc.l	__dist1ints	; 27: Disable timer1 output interrupts
	dc.l	__sine		; 28: Sine function
	dc.l	__def_fk	; 29: Define a function key
	dc.l	__getrand	; 30: Return random number
	dc.l	__set_640	; 31: Set/clear 640 dot mode
	dc.l	__set_vdp	; 32: Set the displayed page
	dc.l	__set_vap	; 33: Set the access page
	dc.l	__set_fgcol	; 34: Set the foreground colour
	dc.l	__set_bgcol	; 35: Set the background colour
	dc.l	__set_bdcol	; 36: Set the border colour
	dc.l	__set_pal	; 37: Define a pallette entry
	dc.l	__rdch_shape	; 38: Get pointer to char shape
	dc.l	__def_chshape	; 39: Define a char shape
	dc.l	__def_wind	; 40: Define a window
	dc.l	__vid_address	; 41: Pixel byte address
	dc.l	__move_wind	; 42: Swap a window
	dc.l	_draw_vchar	; 43: Raw video char O/P
	dc.l	__fill_wind	; 44: Fill a window
	dc.l	__scurs_mode	; 45: Set cursor mode
	dc.l	__mousetrap	; 46: Mouse intercept vector
	dc.l	__fill		; 47: Area fill
	dc.l	_printf		; 48: printf function
	dc.l	_sprintf	; 49: sprintf function
	dc.l	__rset_pel	; 50: Raw pixel set
	dc.l	__set_pel	; 51: Pixel set in window
	dc.l	__rline		; 52: Raw line draw
	dc.l	__line		; 53: Line draw in window
	dc.l	__rread_pel	; 54: Raw pixel read
	dc.l	__read_pel	; 55: Pixel read in window
	dc.l	__sgfgcol	; 56: Set graphics foreground colour
	dc.l	__sgbgcol	; 57: Set graphics background colour
	dc.l	__sgtexture	; 58: Set graphics texture
	dc.l	__rcircle	; 59: Raw circle draw
	dc.l	__circle	; 60: Circle draw in window
	dc.l	__sdotmode	; 61: Set dot draw mode
	dc.l	__getmem	; 62: Get some memory
	dc.l	__getfmem	; 63: Get a particular block of memory
	dc.l	__freemem	; 64: Free a block of memory
	dc.l	__chdir		; 65: Change directory
	dc.l	__mkdir		; 66: Make a directory
	dc.l	__getfullpath	; 67: Get full file path
	dc.l	__pathcmp	; 68: Path compare
	dc.l	__floadrel	; 69: Relocate & load file by pathname
	dc.l	__anipsel	; 70: Select analog I/P
	dc.l	__anopsel	; 71: Select analog O/P
	dc.l	__anopdis	; 72: Disable analog O/P's
	dc.l	__adc		; 73: Perform AD conversion
	dc.l	__dac		; 74: D/A conversion
	dc.l	__set_led	; 75: Set LED
	dc.l	__freetone	; 76: Play free tone
	dc.l	__fttime	; 77: Return freetone status
	dc.l	__rdiport	; 78: Read input port
	dc.l	__rdbiport	; 79: Return buffered I/P port
	dc.l	__setstvec	; 80: Set a system trap vector
	dc.l	__new_cbuf	; 81: Assign new circular buffer area
	dc.l	__prog_sio	; 82: Program serial I/O channel
	dc.l	__gettdstr	; 83: Get time/date string
	dc.l	__nledit	; 84: Edit shorter line
	dc.l	__empty		; 85: Unused (was lbedit)
	dc.l	__ledit		; 86: Raw text edit
	dc.l	__iexec		; 87: Drop into monitor
	dc.l	__exec		; 88: Single monitor command
	dc.l	__callmrd	; 89: Call an MRD
	dc.l	__set_kvec	; 90: Set K/B scan vector
	dc.l	__clparse	; 91: Interpret argument array
	dc.l	__qsort		; 92: Sort code
	dc.l	__sliceargs	; 93: Separate args, expand wildcards
	dc.l	__cpuspeed	; 94: Get CPU speed
	dc.l	__find_driver	; 95: Find named driver number
	dc.l	__get_dvrlist	; 96: Get I or O driver list
	dc.l	__execa		; 97: exec(argv)
	dc.l	__execv		; 98: exec(path, argv)
	dc.l	__option	; 99: Set option
	dc.l	__inst_bdvr	; 100: Install block driver
	dc.l	__coldboot	; 101: Cold start the system
	dc.l	__find_bdvr	; 102: Find a block driver
	dc.l	__blkread	; 103: Read a block
	dc.l	__blkwrite	; 104: Write a block
	dc.l	__open		; 105: Open a file
	dc.l	__read		; 106: Read some bytes
	dc.l	__close		; 107: Close a file
	dc.l	__creat		; 108: Create an O/P file
	dc.l	__write		; 109: Write some bytes
	dc.l	__unlink	; 110: Delete a file
	dc.l	__rename	; 111: Rename a file
	dc.l	__filestat	; 112: Read a file's directory entry
	dc.l	__readdir	; 113: Sequential directory read
	dc.l	__interpbec	; 114: Interpret block I/O error code
	dc.l	__seek		; 115: Seek to file position
	dc.l	__tell		; 116: Return current file pointer position
	dc.l	__bdmisc	; 117: Call block driver misc function
	dc.l	__processdir	; 118: Directory processing
	dc.l	__multiblkio	; 119: Multi-block I/O call
	dc.l	_fprintf	; 120: fprintf
	dc.l	__fputs		; 121: fputs
	dc.l	__errmes	; 122: Return pointer to error message
	dc.l	__fgets		; 123: fgets
	dc.l	__rdalldir	; 124: Read a whole directory
	dc.l	__oscontrol	; 125: Fiddly internal things
	dc.l	__getromver	; 126: Return ROM version number
;	dc.l	__osrequest	; 127: Request OS service
	dc.l	__z80lock	; 127: Z80 arbitration
	dc.l	__aexeca	; 128: Sync/async exec
	dc.l	__proccntl	; 129: Process control
	dc.l	__newchset	; 130: Use a new char set table
	dc.l	__schedprep	; 131: Schedule a process
	dc.l	__pipe		; 132: Create a pipe
	dc.l	__cdmisc	; 133: Char device misc entry point
	dc.l	__empty		; 134: Link system call.
	dc.l	__alias		; 135: Aliasing control
	dc.l	__xbread	; 136: Xbus read
	dc.l	__xbread	; 137: Xbus write
	dc.l	__xbread	; 138: Xbus miscellaneous
	dc.l	__spr		; 139: Low-level printf
	dc.l	__crtc_init	; 140: Program the CRTC
	dc.l	__chkperm	; 141: Check file permissions
	dc.l	__fnledit	; 142: FD based line edit
	dc.l	__set_cpu	; 143: Set the CPU type
	dc.l	__empty		; 144: Unused
	dc.l	__empty		; 145: Unused
	dc.l	__empty		; 146: Unused
	dc.l	__empty		; 147: Unused
	dc.l	__empty		; 148: Unused
	dc.l	__empty		; 149: Unused

;REMEMBER TO CHANGE LIMIT IN COMPARISON ON ENTRY
_jtabe:

