/*
 * The terminal function
 */

#include <types.h>
#include <syscalls.h>
#include <spspace.h>
#include <process.h>
#include <signal.h>
#include <files.h>

EXTERN int curpid;
EXTERN int stdin, stdout, stderr;

/*
 * Terminal mode. Echo until alt-^C hit
 */

rxproc(argc, argv)
char *argv;
{
	int fd, ch;

char buf64;
int blen, nc;

	fd = OPEN(argv1, 1);
#if 0
	for ( ; ; )
	{
		PUTCHAR(ch = GETC(fd));
		if (argc > 2)
			PUTC(stderr, ch);
	}
#endif
	blen = 0;
	for ( ; ; )
	{
		if (blen < sizeof(buf) && (nc = SGETC(fd)))
		{
			while (nc-- && blen < sizeof(buf))
				bufblen++ = GETC(fd);
		}
		else
		{
			WRITE(stdout, buf, blen);
			if (argc > 2)
				WRITE(stderr, buf, blen);
			blen = 0;
		}
	}
}

termkill()
{
	SIGSEND(LASTCHILD(curpid), SIGINT, 0);
	EXIT(0);
}

term(channame, echostderr)
char *channame;		/* The device drivers */
{
	char *argv4;
	int fd;

	fd = OPEN(channame, 1);
	if (fd < 0)
		return cantopen(channame, fd);

	argv0 = "<Rxproc>";
	argv1 = channame;
	argv2 = echostderr ? "-l" : (char *)0;
	argv3 = (char *)0;
	SCHEDPREP(rxproc, argv, SCP_ISASYNC, BIN_STACKSPACE);
	SIGCATCH(termkill);

	for ( ; ; )
		PUTC(fd, rawgetchar());
}

/* 
 * cio stuff
 */

docio(argc, av1)
int av1;		/* Possible terminator char */
{
	register int ntoread, nread, val, retval;
	char ciobuf256;

	ntoread = 1;
	val = av1;
	if (argc == 1)
	{
		val = 0x12345678;
		if (stdin >= NIODRIVERS || stdout >= NIODRIVERS)
			ntoread = sizeof(ciobuf);	/* To/from file */
	}

	for ( ; ; )
	{
		if ((nread = READ(stdin, ciobuf, ntoread)) <= 0)
			return retval = nread;
		if (*ciobuf == val)	/* Match specified end */
			return 0;
		if ((retval = WRITE(stdout, ciobuf, nread)) < 0)
			return retval;
	}
}
